package provide DS9 1.0

proc CreateMenuBar {} {
    global menu

    menu .menuBar -selectcolor $menu(selectcolor)
    .menuBar add cascade -label "File" -menu .menuBar.file -underline 0
    .menuBar add cascade -label "Edit" -menu .menuBar.edit -underline 0
    .menuBar add cascade -label "Frame" -menu .menuBar.frame -underline 3
    .menuBar add cascade -label "Block" -menu .menuBar.block -underline 0
    .menuBar add cascade -label "Zoom" -menu .menuBar.zoom -underline 0
    .menuBar add cascade -label "Scale" -menu .menuBar.scale -underline 0
    .menuBar add cascade -label "Color" -menu .menuBar.color -underline 0
    .menuBar add cascade -label "Region" -menu .menuBar.region -underline 0
    .menuBar add cascade -label "Analysis" -menu .menuBar.analysis -underline 0
    .menuBar add cascade -label "Help" -menu .menuBar.help -underline 0

    # File Menu

    menu .menuBar.file -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 File"
    .menuBar.file add command -label "About DS9..." \
	-command AboutBox -underline 0
    .menuBar.file add separator
    .menuBar.file add command -label "Open..." -command OpenFile -underline 0
    .menuBar.file add command -label "Open Array..." -command OpenArray
    .menuBar.file add command -label "Open URL..." -command OpenURL
    .menuBar.file add separator
    .menuBar.file add command -label "Open Mosaic Image File..." \
	-command OpenMosaicExtFile
    .menuBar.file add command -label "Open Mosaic Image Multiple Files..." \
	-command OpenMosaicFiles
    .menuBar.file add separator
    .menuBar.file add command -label "Open Mosaic Segment..." \
	-command OpenMosaicFile
    .menuBar.file add command -label "Open Mosaic Segment URL..." \
	-command OpenMosaicURL
    .menuBar.file add separator
    .menuBar.file add command -label "Display Fits Header" \
	-command DisplayHeaderMenu -underline 0
    .menuBar.file add command -label "Source TCL..." \
	-command OpenSource -underline 0
    .menuBar.file add separator
    .menuBar.file add command -label "Print..." \
	-command Print -underline 0
    .menuBar.file add command -label "Page Setup..." -command PageDialog
    .menuBar.file add separator
    .menuBar.file add command -label "Exit" -command QuitDS9 -underline 0

    # Edit Menu

    menu .menuBar.edit -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Edit"
    .menuBar.edit add command -label "Cut"
    .menuBar.edit add command -label "Copy" -state disabled
    .menuBar.edit add command -label "Paste" -state disabled
    .menuBar.edit add command -label "Clear" -state disabled
    .menuBar.edit add separator
    .menuBar.edit add radiobutton -label "Pointer" \
	-variable ds9(mode) -value pointer -command ChangeMode -underline 0
    .menuBar.edit add radiobutton -label "Crosshair" \
	-variable ds9(mode) -value crosshair -command ChangeMode -underline 0
    .menuBar.edit add radiobutton -label "Colorbar" \
	-variable ds9(mode) -value colorbar -command ChangeMode -underline 5
    .menuBar.edit add radiobutton -label "Pan" \
	-variable ds9(mode) -value pan -command ChangeMode -underline 1
    .menuBar.edit add radiobutton -label "Zoom" \
	-variable ds9(mode) -value zoom -command ChangeMode -underline 0
    .menuBar.edit add radiobutton -label "Rotate" \
	-variable ds9(mode) -value rotate -command ChangeMode -underline 0
    .menuBar.edit add radiobutton -label "Examine" \
	-variable ds9(mode) -value examine -command ChangeMode -underline 0
    .menuBar.edit add separator
    .menuBar.edit add cascade -label "Preferences" -menu .menuBar.prefs

    # Prefs Menu

    menu .menuBar.prefs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Preferences"
    .menuBar.prefs add checkbutton -label "Information Panel" \
	-variable info(view) -command UpdateView
    .menuBar.prefs add checkbutton -label "Panner" \
	-variable pan(view) -command UpdateView
    .menuBar.prefs add checkbutton -label "Magnifier" \
	-variable mag(view) -command UpdateView
    .menuBar.prefs add checkbutton -label "Buttons" \
	-variable buttons(view) -command UpdateView
    .menuBar.prefs add checkbutton -label "Colorbar" \
	-variable colorbar(view) -command UpdateView
    .menuBar.prefs add separator
    .menuBar.prefs add cascade -label "Infomation Panel" \
	-menu .menuBar.prefs.info
    .menuBar.prefs add cascade -label "WCS" -menu .menuBar.prefs.wcs
    .menuBar.prefs add cascade -label "Frame" -menu .menuBar.prefs.frame
    .menuBar.prefs add cascade -label "Panner" -menu .menuBar.prefs.panner
    .menuBar.prefs add cascade -label "Magnifier" \
	-menu .menuBar.prefs.magnifier
    .menuBar.prefs add cascade -label "Horizontal Graph" \
	-menu .menuBar.prefs.horz
    .menuBar.prefs add cascade -label "Vertical Graph" \
	-menu .menuBar.prefs.vert
    .menuBar.prefs add cascade -label "Dialog Box" -menu .menuBar.prefs.dialog
    .menuBar.prefs add cascade -label "Pan" -menu .menuBar.prefs.pan
    .menuBar.prefs add cascade -label "Tile" -menu .menuBar.prefs.tile
    .menuBar.prefs add cascade -label "Blink Interval" \
	-menu .menuBar.prefs.blink
    .menuBar.prefs add cascade -label "Examine" -menu .menuBar.prefs.examine
    .menuBar.prefs add cascade -label "URL" -menu .menuBar.prefs.url
    .menuBar.prefs add cascade -label "Help" -menu .menuBar.prefs.help
    .menuBar.prefs add cascade -label "Misc" -menu .menuBar.prefs.misc
    .menuBar.prefs add separator
    .menuBar.prefs add command -label "MinMax Parameters..." \
	-command SampleDialog
    .menuBar.prefs add command -label "ZScale Parameters..." \
	-command ZScaleDialog
    .menuBar.prefs add separator
    .menuBar.prefs add command -label "Save Preferences" -command SavePrefs
    .menuBar.prefs add command -label "Clear Preferences" -command ClearPrefs

    # Information Panel Prefs

    menu .menuBar.prefs.info -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Infomation"
    .menuBar.prefs.info add checkbutton -label "Filename" \
	-variable info(filename) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Object" \
	-variable info(object) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Min Max" \
	-variable info(minmax) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Frame Info" \
	-variable info(frame) -command UpdateInfoPanel
    .menuBar.prefs.info add separator
    .menuBar.prefs.info add checkbutton -label "WCS" \
	-variable info(wcs) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Detector" \
	-variable info(detector) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Amplifier" \
	-variable info(amplifier) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Physical" \
	-variable info(physical) -command UpdateInfoPanel
    .menuBar.prefs.info add checkbutton -label "Image" \
	-variable info(image) -command UpdateInfoPanel

    # WCS Prefs

    menu .menuBar.prefs.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs WCS"
    .menuBar.prefs.wcs add radiobutton -label "Equatorial B1950" \
	-variable wcs(system) -value fk4 -underline 11
    .menuBar.prefs.wcs add radiobutton -label "Equatorial J2000" \
	-variable wcs(system) -value fk5 -underline 11
    .menuBar.prefs.wcs add radiobutton -label "ICRS" \
	-variable wcs(system) -value icrs -underline 0
    .menuBar.prefs.wcs add radiobutton -label "Galactic" \
	-variable wcs(system) -value galactic -underline 0
    .menuBar.prefs.wcs add radiobutton -label "Ecliptic" \
	-variable wcs(system) -value ecliptic -underline 0
    .menuBar.prefs.wcs add separator
    .menuBar.prefs.wcs add radiobutton -label "Degrees" \
	-variable wcs(format) -value degrees -underline 0
    .menuBar.prefs.wcs add radiobutton -label "HMS" \
	-variable wcs(format) -value hms -underline 0

    # Frame Prefs

    menu .menuBar.prefs.frame -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Frame"
    .menuBar.prefs.frame add checkbutton -label "Auto Size" \
	-variable canvas(auto) -command UpdateView
    .menuBar.prefs.frame add separator
    .menuBar.prefs.frame add radiobutton -label "256x256" \
	-variable canvas(size) -value 256 -command UpdateView
    .menuBar.prefs.frame add radiobutton -label "512x512" \
	-variable canvas(size) -value 512 -command UpdateView
    .menuBar.prefs.frame add radiobutton -label "1024x1024" \
	-variable canvas(size) -value 1024 -command UpdateView

    # Dialog Prefs

    menu .menuBar.prefs.dialog -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Dialog"
    .menuBar.prefs.dialog add radiobutton -label "Motif" \
	-variable ds9(dialog) -value motif
    .menuBar.prefs.dialog add radiobutton -label "Windows" \
	-variable ds9(dialog) -value windows
    .menuBar.prefs.dialog add radiobutton -label "Blue Plate Special" \
	-variable ds9(dialog) -value blueplate

    # Panner Prefs

    menu .menuBar.prefs.panner -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Panner"
    .menuBar.prefs.panner add checkbutton -label "Orientation Compass" \
	-variable pan(imagecompass) -command ChangeImageCompass
    .menuBar.prefs.panner add checkbutton -label "WCS Compass" \
	-variable pan(wcscompass) -command ChangeWCSCompass
    .menuBar.prefs.panner add checkbutton -label "WCS Compass Tangent Point" \
	-variable pan(wcstanpoint) -command ChangeWCSTanPoint

    # Magnifier Prefs

    menu .menuBar.prefs.magnifier -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Magnifier"
    .menuBar.prefs.magnifier add checkbutton -label "Graphics" \
	-variable mag(region) -command ChangeMagnifierRegion
    .menuBar.prefs.magnifier add checkbutton -label "Cursor" \
	-variable mag(cursor) -command ChangeMagnifierCursor
    .menuBar.prefs.magnifier add separator
    .menuBar.prefs.magnifier add radiobutton -label "Fast" \
	-variable mag(mode) -value fast -command ChangeMagnifierMode
    .menuBar.prefs.magnifier add radiobutton -label "More Accurate" \
	-variable mag(mode) -value accurate -command ChangeMagnifierMode
    .menuBar.prefs.magnifier add separator
    .menuBar.prefs.magnifier add radiobutton -label "2x" \
	-variable mag(zoom) -value 2 -command MagnifierZoomTo
    .menuBar.prefs.magnifier add radiobutton -label "4x" \
	-variable mag(zoom) -value 4 -command MagnifierZoomTo
    .menuBar.prefs.magnifier add radiobutton -label "8x" \
	-variable mag(zoom) -value 8 -command MagnifierZoomTo
    .menuBar.prefs.magnifier add radiobutton -label "16x" \
	-variable mag(zoom) -value 16 -command MagnifierZoomTo
    .menuBar.prefs.magnifier add radiobutton -label "32x" \
	-variable mag(zoom) -value 32 -command MagnifierZoomTo

    # Horizontal Prefs

    menu .menuBar.prefs.horz -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Horizontal"
    .menuBar.prefs.horz add checkbutton -label "Grid" \
	-variable graphHorz(grid) -command UpdateGraphGrid
    .menuBar.prefs.horz add separator
    .menuBar.prefs.horz add radiobutton -label "Linear" \
	-variable graphHorz(log) -value false -command UpdateGraphYAxis
    .menuBar.prefs.horz add radiobutton -label "Log" \
	-variable graphHorz(log) -value true -command UpdateGraphYAxis

    # Vertical Prefs

    menu .menuBar.prefs.vert -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Vertical"
    .menuBar.prefs.vert add checkbutton -label "Grid" \
	-variable graphVert(grid) -command  UpdateGraphGrid
    .menuBar.prefs.vert add separator
    .menuBar.prefs.vert add radiobutton -label "Linear" \
	-variable graphVert(log) -value false -command UpdateGraphYAxis
    .menuBar.prefs.vert add radiobutton -label "Log" \
	-variable graphVert(log) -value true -command UpdateGraphYAxis

    # Pan Prefs

    menu .menuBar.prefs.pan -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Pan"
    .menuBar.prefs.pan add radiobutton -label "Click to Center" \
	-variable pan(mode) -value click
    .menuBar.prefs.pan add radiobutton -label "Drag to Center" \
	-variable pan(mode) -value drag

    # Tile Prefs

    menu .menuBar.prefs.tile -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Tile"
    .menuBar.prefs.tile add radiobutton -label "Grid" \
	-variable tile(mode) -value grid -command DisplayMode
    .menuBar.prefs.tile add radiobutton -label "Column" \
	-variable tile(mode) -value column -command DisplayMode
    .menuBar.prefs.tile add radiobutton -label "Row" \
	-variable tile(mode) -value row -command DisplayMode

    # Blink Prefs

    menu .menuBar.prefs.blink -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Blink"
    .menuBar.prefs.blink add radiobutton -label "1/2 Second" \
	-variable blink(interval) -value 500
    .menuBar.prefs.blink add radiobutton -label "1 Second" \
	-variable blink(interval) -value 1000
    .menuBar.prefs.blink add radiobutton -label "2 Seconds" \
	-variable blink(interval) -value 2000
    .menuBar.prefs.blink add radiobutton -label "4 Seconds" \
	-variable blink(interval) -value 4000
    .menuBar.prefs.blink add radiobutton -label "8 Seconds" \
	-variable blink(interval) -value 8000

    # Examine Prefs

    menu .menuBar.prefs.examine -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Examine"
    .menuBar.prefs.examine add radiobutton -label "New Frame each Time" \
	-variable examine(mode) -value new
    .menuBar.prefs.examine add radiobutton -label "Examine Frame" \
	-variable examine(mode) -value one
    .menuBar.prefs.examine add separator
    .menuBar.prefs.examine add radiobutton -label "1x" \
	-variable examine(zoom) -value 1
    .menuBar.prefs.examine add radiobutton -label "2x" \
	-variable examine(zoom) -value 2
    .menuBar.prefs.examine add radiobutton -label "4x" \
	-variable examine(zoom) -value 4
    .menuBar.prefs.examine add radiobutton -label "8x" \
	-variable examine(zoom) -value 8
    .menuBar.prefs.examine add radiobutton -label "16x" \
	-variable examine(zoom) -value 16

    # URL Prefs

    menu .menuBar.prefs.url -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs URL"
    .menuBar.prefs.url add checkbutton -label "Show FTP Log" -variable ftp(log)
    .menuBar.prefs.url add checkbutton -label "Show HTP Log" \
	-variable http(log)

    # Help Prefs

    menu .menuBar.prefs.help -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Help"
    .menuBar.prefs.help add command -label "Reference Manual URL" \
	-command RefHelpPref
    .menuBar.prefs.help add command -label "Users Manual URL" \
	-command UserHelpPref

    # Misc Prefs

    menu .menuBar.prefs.misc -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Prefs Misc"
    #.menuBar.prefs.misc add checkbutton -label "Use Center of Screen Pixels"
    #-variable ds9(centerpixel)
    #.menuBar.prefs.misc add checkbutton -label "Force Square Pixels" 
    #-variable current(squarePixels) -command ChangeSquarePixels
    .menuBar.prefs.misc add checkbutton -label "Use Cursors" \
	-variable ds9(cursor)
    .menuBar.prefs.misc add checkbutton -label "Scan for Min Max on Load" \
	-variable ds9(scanOnLoad) -command ChangeScanOnLoad

    # Colormap Menu

    menu .menuBar.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Colormap"
    .menuBar.color add separator
    .menuBar.color add command -label "Load Colormap..." \
	-command LoadColorMap -underline 0
    .menuBar.color add command -label "Save Colormap..." \
	-command SaveColorMap -underline 0
    .menuBar.color add separator
    .menuBar.color add checkbutton -label "Invert Colormap" \
	-variable colorbar(invert) -command InvertColorbar -underline 0

    # Frame Menu

    menu .menuBar.frame -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame"
    .menuBar.frame add command -label "New Frame" \
	-command CreateFrame -underline 0
    .menuBar.frame add command -label "Delete Frame" \
	-command DeleteFrameMenu -underline 0
    .menuBar.frame add separator
    .menuBar.frame add command -label "Clear Frame" \
	-command ClearFrame -underline 0
    .menuBar.frame add command -label "Reset Frame" \
	-command ResetFrame -underline 0
    .menuBar.frame add command -label "Refresh Frame" -command UpdateFrame
    .menuBar.frame add separator
    .menuBar.frame add radiobutton -label "Single Frame" \
	-variable ds9(displaymode) -value single -command DisplayMode
    .menuBar.frame add radiobutton -label "Tile Frames" \
	-variable ds9(displaymode) -value tile -command DisplayMode
    .menuBar.frame add radiobutton -label "Blink Frames" \
	-variable ds9(displaymode) -value blink -command DisplayMode
    .menuBar.frame add separator
    .menuBar.frame add cascade -label "Show/Hide Frames" \
	-menu .menuBar.frame.active
    .menuBar.frame add separator
    .menuBar.frame add cascade -label "Match Frames" -menu .menuBar.frame.match
    #.menuBar.frame add checkbutton -label "Lock Frames" -variable ds9(lock)
    .menuBar.frame add command -label "Match Colorbars" \
	-command "MatchColorbars"
    #.menuBar.frame add checkbutton -label "Lock Colorbars" \
	-variable colorbar(lock)
    .menuBar.frame add cascade -label "Lock Crosshairs" \
	-menu .menuBar.frame.crosshair
    .menuBar.frame add separator

    menu .menuBar.frame.active -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Show/Hide"
    .menuBar.frame.active add command -label "Show All" -command ActiveFrameAll
    .menuBar.frame.active add command -label "Hide All" \
	-command ActiveFrameNone
    .menuBar.frame.active add separator

    menu .menuBar.frame.match -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Frame"
    .menuBar.frame.match add command -label "WCS" -command MatchFramesWCS
    .menuBar.frame.match add command -label "Detector"
    .menuBar.frame.match add command -label "Amplifier"
    .menuBar.frame.match add command -label "Physical"
    .menuBar.frame.match add command -label "Image" -command MatchFramesImage

    menu .menuBar.frame.crosshair -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Crosshair"
    .menuBar.frame.crosshair add radiobutton -label "None" \
	-variable crosshair(lock) -value none
    .menuBar.frame.crosshair add radiobutton -label "WCS" \
	-variable crosshair(lock) -value fk5
    .menuBar.frame.crosshair add radiobutton -label "Detector" \
	-variable crosshair(lock) -value detector
    .menuBar.frame.crosshair add radiobutton -label "Amplifier" \
	-variable crosshair(lock) -value amplifier
    .menuBar.frame.crosshair add radiobutton -label "Physical" \
	-variable crosshair(lock) -value physical
    .menuBar.frame.crosshair add radiobutton -label "Image" \
	-variable crosshair(lock) -value image

    # Block Menu

    menu .menuBar.block -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Block"
    .menuBar.block add radiobutton -label "Average" \
	-variable block(function) -value average -command ChangeBlockFunction \
	-underline 0
    .menuBar.block add radiobutton -label "Sum" \
	-variable block(function) -value sum \
	-command ChangeBlockFunction -underline 0
    .menuBar.block add separator
    .menuBar.block add command -label "Block In" \
	-command "Block .5" -underline 6
    .menuBar.block add command -label "Block Out" \
	-command "Block 2" -underline 6
    .menuBar.block add separator
    .menuBar.block add command -label "Block to Fit Frame" \
	-command "BlockToFit"
    .menuBar.block add separator
    .menuBar.block add radiobutton -label "Block 1" \
	-variable block(factor) -value 1 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 2" \
	-variable block(factor) -value 2 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 4" \
	-variable block(factor) -value 4 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 8" \
	-variable block(factor) -value 8 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 16" \
	-variable block(factor) -value 16 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 32" \
	-variable block(factor) -value 32 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 64" \
	-variable block(factor) -value 64 -command ChangeBlockFactor
    .menuBar.block add radiobutton -label "Block 128" \
	-variable block(factor) -value 128 -command ChangeBlockFactor
    .menuBar.block add separator
    .menuBar.block add radiobutton -label "512x512" \
	-variable block(buffersize) -value 512 -command ChangeBlockBufferSize 
    .menuBar.block add radiobutton -label "1024x1024" \
	-variable block(buffersize) -value 1024 -command ChangeBlockBufferSize
    .menuBar.block add radiobutton -label "2048x2048" \
	-variable block(buffersize) -value 2048 -command ChangeBlockBufferSize
    .menuBar.block add radiobutton -label "4096x4096" \
	-variable block(buffersize) -value 4096 -command ChangeBlockBufferSize
    .menuBar.block add separator
    .menuBar.block add command -label "Block To..." -command BlockDialog

    # Zoom Menu

    menu .menuBar.zoom -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Zoom"
    .menuBar.zoom add checkbutton -label "Align to Equatorial WCS" \
	-variable wcs(align) -command AlignWCSFrame -underline 0
    .menuBar.zoom add separator
    .menuBar.zoom add command -label "Zoom In" -command "Zoom 2" -underline 5
    .menuBar.zoom add command -label "Zoom Out" -command "Zoom .5" -underline 5
    .menuBar.zoom add separator
    .menuBar.zoom add command -label "Zoom to Fit Frame" -command "ZoomToFit"
    .menuBar.zoom add separator
    .menuBar.zoom add radiobutton -label "1/16" \
	-variable current(zoom) -value 0.0625 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "1/8" \
	-variable current(zoom) -value 0.125 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "1/4" \
	-variable current(zoom) -value 0.25 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "1/2" \
	-variable current(zoom) -value 0.5 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "1" \
	-variable current(zoom) -value 1 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "2" \
	-variable current(zoom) -value 2 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "4" \
	-variable current(zoom) -value 4 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "8" \
	-variable current(zoom) -value 8 -command ChangeZoom
    .menuBar.zoom add radiobutton -label "16" \
	-variable current(zoom) -value 16 -command ChangeZoom
    .menuBar.zoom add separator
    .menuBar.zoom add command -label "Center" -command CenterFrame -underline 0
    .menuBar.zoom add separator
    .menuBar.zoom add radiobutton  -label "None" \
	-variable current(orient) -value none \
	-command ChangeOrient -underline 0
    .menuBar.zoom add radiobutton  -label "Invert X" \
	-variable current(orient) -value x -command ChangeOrient -underline 7
    .menuBar.zoom add radiobutton -label "Invert Y" \
	-variable current(orient) -value y -command ChangeOrient -underline 7
    .menuBar.zoom add radiobutton -label "Invert X&Y" \
	-variable current(orient) -value xy -command ChangeOrient
    .menuBar.zoom add separator
    .menuBar.zoom add radiobutton -label "0 deg" \
	-variable current(rotate) -value 0 -command ChangeRotate
    .menuBar.zoom add radiobutton -label "90 deg" \
	-variable current(rotate) -value 90 -command ChangeRotate
    .menuBar.zoom add radiobutton -label "180 deg" \
	-variable current(rotate) -value 180 -command ChangeRotate
    .menuBar.zoom add radiobutton -label "270 deg" \
	-variable current(rotate) -value 270 -command ChangeRotate
    .menuBar.zoom add separator
    .menuBar.zoom add command -label "Pan Zoom Rotate To..." \
	-command PanZoomDialog

    # Scale Menu

    menu .menuBar.scale -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale"
    .menuBar.scale add radiobutton -label "Min Max" \
	-variable scale(mode) -command ScaleMode -value minmax -underline 0
    .menuBar.scale add radiobutton -label "IRAF ZScale" \
	-variable scale(mode) -command ScaleMode -value zscale -underline 5
    .menuBar.scale add command -label "User Limits..." \
	-command ScaleLimitsDialog -underline 0
    .menuBar.scale add separator
    .menuBar.scale add cascade -label "Scope" -menu .menuBar.scale.scope
    .menuBar.scale add cascade -label "Min Max Options" \
	-menu .menuBar.scale.minmax
    .menuBar.scale add separator
    .menuBar.scale add radiobutton -label "Linear" \
	-variable current(scale) -command ChangeColorScale \
	-value linear -underline 0
    .menuBar.scale add radiobutton -label "Log" \
	-variable current(scale) -command ChangeColorScale \
	-value log -underline 2
    .menuBar.scale add radiobutton -label "Squared" \
	-variable current(scale) -command ChangeColorScale \
	-value squared -underline 1
    .menuBar.scale add radiobutton -label "Square Root" \
	-variable current(scale) -command ChangeColorScale \
	-value sqrt -underline 0

    menu .menuBar.scale.scope -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale Scope"
    .menuBar.scale.scope add radiobutton -label "Global" \
	-variable scale(scope) -command ScaleScope -value global
    .menuBar.scale.scope add radiobutton -label "Local" \
	-variable scale(scope) -command ScaleScope -value local

    menu .menuBar.scale.minmax -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale Min Max"
    .menuBar.scale.minmax add radiobutton -label "Scan Data" \
	-variable minmax(mode) -command MinMaxMode -value scan
    .menuBar.scale.minmax add radiobutton -label "Sample Data" \
	-variable minmax(mode) -command MinMaxMode -value sample
    .menuBar.scale.minmax add radiobutton -label "DATAMIN DATAMAX" \
	-variable minmax(mode) -command MinMaxMode -value datamin
    .menuBar.scale.minmax add radiobutton -label "IRAF-MIN IRAF-MAX" \
	-variable minmax(mode) -command MinMaxMode -value irafmin

    # Region Menu

    menu .menuBar.region -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region"
    .menuBar.region add command -label "Get Info..." \
	-command InfoMarker -underline 0
    .menuBar.region add separator
    .menuBar.region add cascade -label "Shape" \
	-menu .menuBar.region.shape -underline 0
    .menuBar.region add cascade -label "Color" \
	-menu .menuBar.region.color -underline 0
    .menuBar.region add cascade -label "Properties" \
	-menu .menuBar.region.properties -underline 0
    .menuBar.region add cascade -label "Font" \
	-menu .menuBar.region.font -underline 3
    .menuBar.region add separator
    .menuBar.region add command -label "Move to Front" \
	-command FrontMarker -underline 8
    .menuBar.region add command -label "Move to Back" \
	-command BackMarker -underline 8
    .menuBar.region add separator
    .menuBar.region add command -label "Select All" \
	-command SelectAllMarker -underline 7
    .menuBar.region add command -label "Select None" \
	-command UnselectAllMarker -underline 7
    .menuBar.region add separator
    .menuBar.region add command -label "Delete All" \
	-command DeleteAllMarker -underline 0
    .menuBar.region add separator
    .menuBar.region add command -label "Load Regions..." \
	-command OpenMarkerFile -underline 0
    .menuBar.region add command -label "Save Regions..." -command SaveMarker
    .menuBar.region add command -label "List Regions" \
	-command DisplayMarkerList
    .menuBar.region add separator
    .menuBar.region add cascade -label "Save/List Format" \
	-menu .menuBar.region.saveformat
    .menuBar.region add cascade -label "Save/List Coordinate System" \
	-menu .menuBar.region.savecoord

    menu .menuBar.region.shape -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Shape"
    .menuBar.region.shape add radiobutton \
	-label "Circle" -variable marker(shape) -value circle  -underline 0
    .menuBar.region.shape add radiobutton \
	-label "Ellipse" -variable marker(shape) -value ellipse -underline 0
    .menuBar.region.shape add radiobutton \
	-label "Rectangle" -variable marker(shape) \
	-value rectangle -underline 0
    .menuBar.region.shape add radiobutton \
	-label "Polygon" -variable marker(shape) -value polygon -underline 0
    .menuBar.region.shape add radiobutton \
	-label "Line" -variable marker(shape) -value line -underline 0
    .menuBar.region.shape add radiobutton \
	-label "Text" -variable marker(shape) -value text -underline 0
    .menuBar.region.shape add radiobutton \
	-label "Ruler" -variable marker(shape) -value ruler -underline 1
    .menuBar.region.shape add separator
    .menuBar.region.shape add radiobutton \
	-label "Circle Point" -variable marker(shape) -value "circle point" 
    .menuBar.region.shape add radiobutton \
	-label "Box Point" -variable marker(shape) -value "box point"
    .menuBar.region.shape add radiobutton \
	-label "Diamond Point" -variable marker(shape) -value "diamond point"
    .menuBar.region.shape add radiobutton \
	-label "Cross Point" -variable marker(shape) -value "cross point"
    .menuBar.region.shape add radiobutton \
	-label "X Point" -variable marker(shape) -value "x point"
    .menuBar.region.shape add radiobutton \
	-label "Arrow Point" -variable marker(shape) -value "arrow point" 
    .menuBar.region.shape add radiobutton \
	-label "BoxCircle Point" -variable marker(shape) \
	-value "boxcircle point"

    menu .menuBar.region.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Color"
    .menuBar.region.color add radiobutton -label "Black" \
	-variable marker(color) -value black \
	-command ChangeMarkerColor -underline 4
    .menuBar.region.color add radiobutton -label "White" \
	-variable marker(color) -value white \
	-command ChangeMarkerColor -underline 0
    .menuBar.region.color add radiobutton -label "Red" \
	-variable marker(color) -value red \
	-command ChangeMarkerColor -underline 0
    .menuBar.region.color add radiobutton -label "Green" \
	-variable marker(color) -value green \
	-command ChangeMarkerColor -underline 0
    .menuBar.region.color add radiobutton -label "Blue" \
	-variable marker(color) -value blue \
	-command ChangeMarkerColor -underline 0
    .menuBar.region.color add radiobutton -label "Cyan" \
	-variable marker(color) -value cyan \
	-command ChangeMarkerColor -underline 0
    .menuBar.region.color add radiobutton -label "Magenta" \
	-variable marker(color) -value magenta \
	-command ChangeMarkerColor -underline 0
    .menuBar.region.color add radiobutton -label "Yellow" \
	-variable marker(color) -value yellow \
	-command ChangeMarkerColor -underline 0

    menu .menuBar.region.properties -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Properties"
    .menuBar.region.properties add checkbutton -label "Can Edit" \
	-variable marker(edit) -command "ChangeMarkerProp edit" -underline 4
    .menuBar.region.properties add checkbutton -label "Can Move" \
	-variable marker(move) -command "ChangeMarkerProp move" -underline 4
    .menuBar.region.properties add checkbutton -label "Can Rotate" \
	-variable marker(rotate) -command "ChangeMarkerProp rotate" \
	-underline 4
    .menuBar.region.properties add checkbutton -label "Can Delete" \
	-variable marker(delete) -command "ChangeMarkerProp delete" \
	-underline 4
    .menuBar.region.properties add checkbutton -label "Include/Exclude" \
	-variable marker(include) -command "ChangeMarkerProp include" \
	-underline 0
    .menuBar.region.properties add checkbutton -label "Fixed in Size" \
	-variable marker(fixed) -command "ChangeMarkerProp fixed" \
	-underline 0

    menu .menuBar.region.font -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Font"
    .menuBar.region.font add radiobutton -label "Default" \
	-variable marker(font) -value system -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add radiobutton -label "Times" \
	-variable marker(font) -value times -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add radiobutton -label "Helvetica" \
	-variable marker(font) -value helvetica -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add radiobutton -label "Symbol" \
	-variable marker(font) -value symbol -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add radiobutton -label "Courier" \
	-variable marker(font) -value courier -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add separator
    .menuBar.region.font add radiobutton -label "9" \
	-variable marker(fontSize) -value 9 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "10" \
	-variable marker(fontSize) -value 10 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "12" \
	-variable marker(fontSize) -value 12 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "14" \
	-variable marker(fontSize) -value 14 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "18" \
	-variable marker(fontSize) -value 18 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "24" \
	-variable marker(fontSize) -value 24 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "30" \
	-variable marker(fontSize) -value 30 -command ChangeMarkerFont
    .menuBar.region.font add radiobutton -label "36" \
	-variable marker(fontSize) -value 36 -command ChangeMarkerFont
    .menuBar.region.font add separator
    .menuBar.region.font add radiobutton -label "Plain" \
	-variable marker(fontStyle) -value normal -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add radiobutton -label "Bold" \
	-variable marker(fontStyle) -value bold -command ChangeMarkerFont \
	-underline 0
    .menuBar.region.font add radiobutton -label "Italic" \
	-variable marker(fontStyle) -value italic -command ChangeMarkerFont \
	-underline 0

    menu .menuBar.region.saveformat -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Format"
    .menuBar.region.saveformat add radiobutton -label "DS9" \
	-variable marker(saveformat) -value ds9 -command UpdateMarkerFormatMenu
    .menuBar.region.saveformat add radiobutton -label "SAOtng" \
	-variable marker(saveformat) -value saotng \
	-command UpdateMarkerFormatMenu
    .menuBar.region.saveformat add radiobutton -label "SAOimage" \
	-variable marker(saveformat) -value saoimage \
	-command UpdateMarkerFormatMenu
    .menuBar.region.saveformat add radiobutton -label "IRAF PROS" \
	-variable marker(saveformat) -value pros \
	-command UpdateMarkerFormatMenu

    menu .menuBar.region.savecoord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Coordinate"
    .menuBar.region.savecoord add radiobutton -label "Equatorial B1950" \
	-variable marker(savecoord) -value fk4
    .menuBar.region.savecoord add radiobutton -label "Equatorial J2000" \
	-variable marker(savecoord) -value fk5
    .menuBar.region.savecoord add radiobutton -label "ICRS" \
	-variable marker(savecoord) -value icrs
    .menuBar.region.savecoord add radiobutton -label "Galactic" \
	-variable marker(savecoord) -value galactic
    .menuBar.region.savecoord add radiobutton -label "Ecliptic" \
	-variable marker(savecoord) -value ecliptic
    .menuBar.region.savecoord add separator
    .menuBar.region.savecoord add radiobutton -label "Detector" \
	-variable marker(savecoord) -value detector
    .menuBar.region.savecoord add radiobutton -label "Amplifier" \
	-variable marker(savecoord) -value amplifier
    .menuBar.region.savecoord add radiobutton -label "Physical" \
	-variable marker(savecoord) -value physical
    .menuBar.region.savecoord add radiobutton -label "Image" \
	-variable marker(savecoord) -value image
    .menuBar.region.savecoord add separator
    .menuBar.region.savecoord add radiobutton -label "Degrees" \
	-variable marker(savecoordformat) -value degrees
    .menuBar.region.savecoord add radiobutton -label "HMS" \
	-variable marker(savecoordformat) -value hms

    # Analysis Menu

    menu .menuBar.analysis -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Analysis"
    .menuBar.analysis add checkbutton -label "Horizontal Graph" \
	-variable graphHorz(view) -command UpdateView
    .menuBar.analysis add checkbutton -label "Vertical Graph" \
	-variable graphVert(view) -command UpdateView
    .menuBar.analysis add separator
    .menuBar.analysis add command -label "Contours" -command ContourDialog
    .menuBar.analysis add separator

    # Help Menu

    menu .menuBar.help -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Help"
    .menuBar.help add command -label "Reference Manual" -command RefHelp
    .menuBar.help add command -label "User's Manual" -command UserHelp
    .menuBar.help add separator
    .menuBar.help add command -label "Help Desk" -command HelpDesk
}
