#include <sys/shm.h>

#include "share.h"

FitsShare::FitsShare(int key, int sz, const char* filter)
{
  parse(filter);

  // Attach the memory segment

  mapsize_ = sz;
  int shmid;
  if ((shmid = shmget(key, sz, IPC_CREAT)) < 0)
    return;
  if ((mapdata_ = (char*)shmat(shmid, 0, SHM_RDONLY)) < 0)
    return;

  // so far so good
  valid_ = 1;
}

FitsShare::~FitsShare()
{
  shmdt(mapdata_);
}

FitsFitsShare::FitsFitsShare(int key, int sz, const char* filter, 
			     ScanMode mode) : FitsShare(key, sz, filter)
{
  if (valid_)
    if (mode == EXACT || pExt_ || pIndex_)
      processExact();
    else
      processRelax();
}

FitsArrShare::FitsArrShare(int key, int sz, const char* filter) 
  : FitsShare(key, sz, filter)
{
  if (valid_)
    processArray();
}

FitsMosaicShare::FitsMosaicShare(int key, int sz) : FitsShare(key, sz, "")
{
  if (valid_)
    processMosaic();
}
