#ifndef __contour_h__
#define __contour_h__

#include "vector.h"
#include "list.h"
#include "contourscale.h"
#include "frame.h"

class FitsImage;

class ContourPlot {
protected:
  Frame* parent;
  List<Vertex>* contours;
  char* colorName;
  int color_;

public:
  ContourPlot(Frame*, const char*);
  ContourPlot(Frame*, const char*, List<Vertex>*);
  virtual ~ContourPlot();

  void render();
  void ps(Frame::PSColorSpace);
  void color(const char*);
  const char* getColor() {return colorName;}
  List<Vertex>* dup();
};

#endif




